<template>
  <div style="padding-left: 5px">
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">基础信息管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/routeInfo">线路管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <el-form
      ref="queryForm"
      :model="queryModel"
      inline
      class="demo-form-inline"
    >
      <el-form-item label="所属公司" prop="companyId">
        <el-select-tree
          size="mini"
          :props="props"
          :options="companyResult"
          v-model="queryModel.companyId"
          height="200"
        ></el-select-tree>
      </el-form-item>
      <el-form-item label="路线名称" prop="name">
        <el-input type="text" size="mini" v-model="queryModel.name"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
          >查询</el-button
        >&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
          >重置</el-button
        >&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        @click="handleAdd"
        >新增</el-button
      >
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-remove"
        :disabled="multipleSelection.length == 0"
        @click="handleBatchDelete"
        >删除选中项</el-button
      >
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-upload2"
        @click="batchImportVisible = true"
        >导入</el-button
      >
    </el-row>
    <el-table
      ref="formTable"
      :data="tableData"
      v-loading="loading"
      stripe
      :height="tableHeight"
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column
        prop="companyName"
        label="所属单位"
        width="130"
      ></el-table-column>
      <el-table-column
        prop="name"
        label="路线名称"
      ></el-table-column>
      <el-table-column
        prop="regionName"
        label="地区"
        width="90"
      ></el-table-column>
      <el-table-column
        prop="startTime"
        label="开始时间"
        width="100"
      ></el-table-column>
      <el-table-column
        prop="endTime"
        label="结束时间"
        width="100"
      ></el-table-column>
      <el-table-column
        prop="interval"
        label="间隔时间(分钟)"
        width="120"
      ></el-table-column>
      <el-table-column label="操作" width="400">
        <template slot-scope="{ row }">
          <el-button size="mini" type="warning" @click="handleEdit(row)"
            >编辑</el-button
          >
          <el-button size="mini" type="success" @click="handleEditPath(row)"
            >路线绘制</el-button
          >
          <el-button size="mini" type="success" @click="handleEditPrice(row)"
            >费用查看</el-button
          >
          <el-button size="mini" type="primary" @click="handleTimeTable(row)"
            >时刻表</el-button
          >
          <el-button size="mini" type="danger" @click="handleDelete(row)"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <routeInfo-detail
      v-if="showModal"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></routeInfo-detail>
    <routeTimeTable-list
      v-if="showModal2"
      :routeId="routeId"
      :title="modalTitle2"
      @close="onDetailModalClose2"
    ></routeTimeTable-list>
    <el-dialog
      width="80%"
      top="5vh"
      :visible.sync="showMapDialog"
      title="路线绘制"
      :modal-append-to-body="true"
      :append-to-body="true"
      style="text-align: left"
      :close-on-click-modal="false"
      v-loading="mapLoading"
    >
      <el-amap
        ref="roadlineMap"
        vid="roadlineMap"
        :plugin="plugin"
        :center="centerPoint"
        :zoom="15"
        style="width: 100%; height: 500px"
      >
        <!--站点-->
        <el-amap-marker
          :zIndex="1"
          v-for="station in stationList"
          :key="station.id"
          :position="station.position"
          :title="station.title"
          :icon="station.icon"
        ></el-amap-marker>
        <!--路线-->
        <el-amap-polyline
          :path="mapPath"
          :zIndex="2"
          :isOutline="true"
          :outlineColor="'#ffeeff'"
          :borderWeight="3"
          :strokeColor="'#3366FF'"
          :strokeOpacity="1"
          :strokeWeight="6"
          :strokeStyle="'solid'"
          :strokeDasharray="[10, 5]"
          :lineJoin="'round'"
          :lineCap="'round'"
          :editable="true"
        ></el-amap-polyline>
      </el-amap>
      <span slot="footer" class="dialog-footer">
        <el-button @click="handleConnectStation()">站点连线</el-button>
        <el-button @click="handleMapPathConfirm()">确定</el-button>
        <el-button @click="showMapDialog = false">关闭</el-button>
      </span>
    </el-dialog>
    <el-dialog
      title="导入"
      :visible.sync="batchImportVisible"
      :modal-append-to-body="false"
      style="text-align: left"
      :close-on-click-modal="false"
    >
      <el-form label-width="150px">
        <el-form-item label="模板下载">
          <el-link
            href="http://rccs.oss-cn-hangzhou.aliyuncs.com/smart-bus/excel/routeInfo.xls"
            type="primary"
            target="_blank"
            >点击下载模板</el-link
          >
        </el-form-item>
        <el-form-item label="上传文件">
          <el-upload
            class="upload-demo"
            accept=".xls"
            :action="uploadUrlXls"
            :data="uploadXlsData"
            :headers="headers"
            :on-preview="handleBatchImportPreview"
            name="uploadFile"
            :multiple="true"
            :limit="1"
            :on-remove="handleBatchImportRemove"
            :before-remove="beforeBatchImportRemove"
            :before-upload="beforeUpload"
            :on-exceed="handleBatchImportExceed"
            :on-success="handleBatchImportSuccess"
            :file-list="batchImportFileList"
          >
            <el-button size="small" type="primary" :loading="xlsLoading"
              >点击上传</el-button
            >
            <div slot="tip" class="el-upload__tip">
              只能上传xls文件，且不超过500kb
            </div>
          </el-upload>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="batchImportVisible = false"
          >关 闭</el-button
        >
      </div>
    </el-dialog>
    <!--批量导入E-->
  </div>
</template>
<script>
import Constant from "@/constant";
import routeInfoDetail from "./routeInfo-detail";
import routeTimeTableList from "./routeTimeTable-list";
import routeInfoApi from "@/api/bus/routeInfo";
import SelectTree from "@/components/SelectTree";
import companyInfoApi from "@/api/bus/companyInfo";

import stationIcon from "@/assets/icons/station.svg";
import greenIcon from "@/assets/icons/green.svg";
import redIcon from "@/assets/icons/red.svg";


import { getToken } from "@/utils/auth"; // get token from cookie
import "nprogress/nprogress.css"; // progress bar style

export default {
  name: "BusDriverInfoList",
  data() {
    var self = this;
    return {
      activeName: "list",
      queryModel: {
        name: "",
        companyId: "",
      },
      loading: false,
      tableData: [],
      treeData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      modalTitle: "",
      showModal2: false,
      modalTitle2: "",
      businessKey: "",
      routeId:"",
      tableHeight: 300,
      showDeviceModal: false,
      companyId: "",
      qrCode: "",
      companyResult: [],
      props: {
        // 配置项（必选）
        value: "id",
        label: "name",
        children: "children",
      },
      batchImportVisible: false,
      batchImportFileList: [],
      showMapDialog: false,
      showPriceModal: false,
      uploadUrlXls: Constant.serverUrl + "/bus/routeInfo/importXls",
      uploadXlsData: {
        subFolder: "driver",
      },
      headers: {
        Authorization: getToken(),
      },
      xlsLoading: false,
      sceneData: [],
      typeData: [],
      selectRoute: null,
      centerPoint: [112.276585, 30.306401],
      stationList: [
        { id: 1, position: [112.276585, 30.306401], content: "" },
        { id: 2, position: [112.275276, 30.306827], content: "" },
      ],
      mapPath: [
        [112.276585, 30.306401],
        [112.275276, 30.306827],
      ],
      mapLoading: false,
      plugin: [
        {
          pName: "ToolBar",
          events: {
            init(instance) {
              console.log(instance);
            },
          },
        },
      ],
    };
  },
  created() {
    var self = this;

    companyInfoApi.treeList().then(function (response) {
      var jsonData = response.data;
      if (jsonData.result) {
        self.companyResult = jsonData.data;
      }
    });

    this.changePage(1);
  },
  methods: {
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      if (self.queryModel.companyId != null) {
        formData.append("companyId", self.queryModel.companyId);
      }

      formData.append("name", self.queryModel.name);

      routeInfoApi
        .pageList(formData)
        .then(function (response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
          //45为分页栏的高度
          //页面高度-列表上面的高度-分页栏高度
          self.tableHeight =
            window.innerHeight - self.$refs.formTable.$el.offsetTop - 100;
        })
        .catch((error) => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order == "ascending" ? "asc" : "desc";

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
      this.queryModel.companyId = "";
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleTimeTable(record) {
      this.modalTitle2 =record.name + "-时刻表";
      this.routeId = record.id;
      this.showModal2 = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          routeInfoApi.remove(record.id).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!",
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map((record) => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        routeInfoApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!",
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;
      this.showDeviceModal = false;
      this.showPriceModal = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },
    onDetailModalClose2(refreshed) {
      //保存成功后回调
      this.showModal2 = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },

    beforeUpload(file, fileList) {
      //导入前判断
    },
    //批量导入-上传成功
    handleBatchImportSuccess(response, file, fileList) {
      var self = this;
      self.xlsLoading = false;
      if (response.result) {
        self.$message.success(response.message);
        this.batchImportFileList = [];
        this.changePage(1);
        this.uploadCompanyId = "";
        this.uploadXlsData.companyId = "";
        this.batchImportVisible = false;
      } else {
        //this.$message.error(response.message);
        this.batchImportFileList = [];
        this.changePage(1);
        this.uploadCompanyId = "";
        this.uploadXlsData.companyId = "";

        if (response.data != null) {
          //下载有错误信息提示的报表
          //window.open(response.data);
          self.$message({
            showClose: true,
            dangerouslyUseHTMLString: true,
            message:
              response.message +
              `,<a href="${response.data}" target="_blank">点击下载未导入的数据报表</a>&nbsp;`,
            duration: 30000,
          });
        }
      }
    },
    //批量导入-预览
    handleBatchImportPreview(file) {
      console.log(file.url);
    },
    //批量导入-移除
    handleBatchImportRemove(file, fileList) {
      console.log(file, fileList);
    },
    //批量导入-移除前操作
    beforeBatchImportRemove(file, fileList) {
      console.log(file, fileList);
    },
    //批量导入-文件超出个数限制时的钩子
    handleBatchImportExceed(files, fileList) {
      this.$message.warning(
        `当前限制选择 3 个文件，本次选择了 ${files.length} 个文件，共选择了 ${
          files.length + fileList.length
        } 个文件`
      );
    },
    handleMapPathConfirm() {
      this.mapLoading = true;

      var pathList = this.mapPath.map((item) => {
        return item.lng + "," + item.lat;
      });

      routeInfoApi
        .updateMapPath({
          id: this.selectRoute.id,
          pathList: pathList,
        })
        .then((response) => {
          this.mapLoading = false;

          var jsonData = response.data;

          if (jsonData.result) {
            this.showMapDialog = false;
            this.$message.success("保存成功!");
          } else {
            this.$message.warning("系统错误!" + jsonData.message);
          }
        });
    },
    handleConnectStation() {
      this.$confirm("是否确认根据站点重新绘制路线?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        this.mapPath = [];
        this.stationList.forEach((item) => {
          this.mapPath.push(item.position);
        });
      });
    },
    handleEditPath(row) {
      //读取当前路线的站点
      this.loading = true;

      routeInfoApi.edit(row.id).then((response) => {
        this.loading = false;

        var jsonData = response.data;
        var model = jsonData.data;

        var _stationList = model.stationList;

        if (model.pathList != null) {
          this.mapPath = model.pathList.map((item) => {
            return item.split(",");
          });

          this.centerPoint = this.mapPath[0];
        } else {
          this.mapPath = [];
        }

        if (_stationList.length <= 1) {
          this.$message.warning("请先至少设置2个站点!");
        } else {
          this.selectRoute = row;
          this.showMapDialog = true;

          this.stationList = [];

          var initMapPath = this.mapPath.length == 0;

          _stationList.forEach((item) => {
            if (item.location != null && item.location.length > 0) {
              var station = {
                id: item.id,
                title: item.name,
                position: item.location.split(","),
                icon: stationIcon
              };

              this.stationList.push(station);

              if(item.stationSubInfoList!=null){
                  item.stationSubInfoList.forEach(subItem=>{
                      var startToEnd = subItem.startStationId == this.stationList[0].id;

                      this.stationList.push({
                          id: subItem.id,
                          title: item.name + "入口" + (startToEnd ? "(起)" : "(终)"),
                          position: [subItem.longitude,subItem.latitude],
                          icon: startToEnd ? greenIcon : redIcon
                      });
                  });
              }

              if (initMapPath) {
                this.mapPath.push(station.position);
              }
            }
          });

          if (this.mapPath.length > 0) {
            this.centerPoint = this.mapPath[0];
          }
        }
      });
    },
    handleEditPrice(record) {
      var path = "/bus/routeInfo/priceList";

      this.$store
        .dispatch("tagsView/delView", {
          name: "BusRouteInfoList",
          path: path,
        })
        .then(({ visitedViews }) => {
          this.$router.push({
            path: path,
            query: {
              routeId: record.id,
            },
          });
        });
    },
  },
  mounted: function () {},
  components: {
    "routeInfo-detail": routeInfoDetail,
    "el-select-tree": SelectTree,
    "routeTimeTable-list":routeTimeTableList
  },
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>